package controleurs;

import dao.ThreadDAO;
import dao.UserDAO;
import dto.Message;
import dto.MyThread;
import dto.User;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import java.io.PrintWriter;
import java.io.IOException;
import java.sql.SQLException;
import java.util.List;

@WebServlet("/Discover")
public class Discover extends HttpServlet {
    public void service(HttpServletRequest req, HttpServletResponse res)
            throws IOException {
        if (req.getSession().getAttribute("user") != null) {
            UserDAO userDao = new UserDAO();
            ThreadDAO threadDao = new ThreadDAO();
            PrintWriter out = res.getWriter();
            String login = (String) req.getSession().getAttribute("login");

            User user = (User) req.getSession().getAttribute("user");

            if (user != null) {
                List<Message> messages = null;
                messages = threadDao.getAllMessages();

                out.println("<html><body><meta charset=\"utf-8\">");
                out.println("<link rel=\"stylesheet\" href=\"css/feed.css\">");
                out.println("<title>Discover</title>");

                out.println("<h1>Discover the threads you're not following yet</h1>");

                out.println(PageGeneration.generateNavMenu());

                List<Integer> followedThreads = null;

                try {
                    followedThreads = userDao.getThreadsFollowedByUser(user);
                }
                catch (SQLException sqle) {
                    sqle.getStackTrace();
                }

                if (!messages.isEmpty()) {
                    for (Message message : messages) {
                        MyThread msgThread = null;
                        try {
                            msgThread = threadDao.getThreadById(message.getThreadId());
                        } catch (SQLException e) {
                            throw new RuntimeException(e);
                        }
                        User sender = userDao.getUserById(message.getSenderId());
                        String senderName = sender.getUserName();
                        boolean followed = followedThreads.contains(msgThread.getId());
                        
                        out.println("<div class=\"message\">");
                        out.println("<h3 class=\"msgThread\">" + msgThread.getThreadName() + "</h3>");
                        out.println("<p class=\"msgContent\">" + message.getContent() + "</p>");
                        out.println("<p class=\"sender\">by " + senderName + "</p>");

                        out.println("<form class=\"followThread\" action=\"http://localhost:8080/s4a021-web-backend/FollowThread\" method=\"post\">");
                        out.println("<input name=\"threadid\" type=\"hidden\" value=\"" + msgThread.getId() +"\">");
                        
                        if (followed) {
                            out.println("<button class=\"followed\" type=\"submit\">Followed</button>");
                        }
                        else if (!followed) {
                            out.println("<button class=\"unfollowed\" type=\"submit\">Follow</button>");
                        }
                        out.println("</form>");
                    }
                }
                else {
                    out.println("<p class=\"information\">No new thread to discover for now !</p>");
                }

                out.println("<div class=\"discover\">");
                out.println("<a href=\"http://localhost:8080/s4a021-web-backend/NewThread\">Create a new thread</a>");
                out.println("</div>");

                out.println("</body>");
                out.println("<footer>");
                out.println("Connected as " + login);
                out.println("</footer>");
                out.println("</html>");

            }


        } else {
            res.sendRedirect("http://localhost:8080/s4a021-web-backend/index.html");
        }

    }

}
