package controleurs;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import dao.ThreadDAO;
import dao.UserDAO;
import dto.MyThread;
import dto.User;

@WebServlet("/Followed")
public class Following extends HttpServlet {
    public void service(HttpServletRequest req, HttpServletResponse res) 
    throws IOException {
        if (req.getSession().getAttribute("user") != null) {
            PrintWriter out = res.getWriter();
            UserDAO userDAO = new UserDAO();
            ThreadDAO threadDao = new ThreadDAO();

            String login = (String) req.getSession().getAttribute("login");
            User user = (User) req.getSession().getAttribute("user");
            if (!userDAO.isDatabased(user)) res.sendRedirect("http://localhost:8080/s4a021-web-backend/index.html");

            List<Integer> threadsFollowedByUser = null;
           try {
               threadsFollowedByUser = userDAO.getThreadsFollowedByUser(user);
           }
           catch (SQLException sqle) {
               sqle.getStackTrace();
           }

            System.out.println(threadsFollowedByUser.size());

            out.println("<html><body><meta charset=\"utf-8\">");
            out.println("<link rel=\"stylesheet\" href=\"css/feed.css\">");
            out.println("<title>Followed</title>");
            
            out.println("<nav>");
            out.println("<ul class=\"menu\">");
            out.println("<li class=\"menu_option\"><a href=\"http://localhost:8080/s4a021-web-backend/Welcome\">\uD83C\uDFE0 Home</a></li>");
            out.println("<li class=\"menu_option\"><a href=\"http://localhost:8080/s4a021-web-backend/Followed\">\uD83E\uDDF5 Followed</a></li>");
            out.println("<li class=\"menu_option\"><a href=\"http://localhost:8080/s4a021-web-backend/Account\">\uD83D\uDC64 Account</a></li>");
            out.println("</ul></nav>");

            out.println("<h1>Threads followed</h1>");

            if (!threadsFollowedByUser.isEmpty()) {
                for (Integer t : threadsFollowedByUser) {
                    MyThread thread = null;
                    try {
                        thread = threadDao.getThreadById(t);
                    }
                    catch (SQLException sqle) {
                        sqle.getStackTrace();
                    }
                    LocalDate followDate = null;
                    try {
                        followDate = userDAO.getFollowDateOfThread(user, thread);
                    }
                    catch (SQLException sqle) {
                        sqle.getStackTrace();
                    }

                    out.println("<div class=\"thread\">");
                    out.println("<h3 class=\"threadname\">Thread name: " + thread.getThreadName() + "</h3>");
                    out.println("<p class=\"followDate\">Following since: " + followDate + "</p>");
                    out.println("</div>");
                }
            }
            else {
                out.println("<h3>You are not following any thread yet.</h3>");
                out.println("<button><a href=\"\">Discover new threads</a></button>");
            }

            out.println("</body>");
            out.println("<footer>");
            out.println("Connected as " + login);
            out.println("</footer>");
            out.println("</html>");
        }
        else {
            res.sendRedirect("http://localhost:8080/s4a021-web-backend/index.html");
        }

    }
    
}
